#!/usr/bin/perl
#
#   DreamBot - An Experimental IRC Bot written in Perl.
#   Copyright (C) 1999-2002  Osman "spectre" Keskin
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
$ver     = "DreamBot 0.0.7";
$version = "$ver - Experimental Perl Bot";
$config  = "config";

$curserver = 0;
$curnick   = 0;
$seenflag  = false;
$bitchflag = false;
$params    = "";

for ($i = 0; $i < $#ARGV + 1; $i++)
{
  if ($ARGV[$i] eq "-h" || $ARGV[$i] eq "--help")
  {
    printf("$version\n");
    printf("Usage: $0 <options>\n\n");
    printf("  -c --config <config>        use the <config> file for configuration\n");
    printf("  -d --datadir <datadir>      sets the datadir, default is set in config file\n");
    printf("  -h --help                   help\n");
    exit(0);
  }
  elsif ($ARGV[$i] eq "-c" || $ARGV[$i] eq "--config")
  {
    $i++;
    if ($ARGV[$i] ne "")
    {
      $config = $ARGV[$i];
      $params .= " -c $config";
    }
    else
    {
      printf("Usage:\n  --config <config>\n");
      exit(0);
    }
  }
  elsif ($ARGV[$i] eq "-d" || $ARGV[$i] eq "--datadir")
  {
    $i++;
    if ($ARGV[$i] ne "")
    {
      $newdatadir = $ARGV[$i];
      $params .= " -d $datadir";
    }
    else
    {
      printf("Usage:\n  --datadir <datadir>\n");
      exit(0);
    }
  }
}

if (open(FILE, "$ENV{HOME}/.dreambot.pid"))
{

  # $pid = <FILE>;
  close(FILE);

  # if ($$ eq $pid) { exit(0); }
  exit(0);
}

open(FILE, ">$ENV{HOME}/.dreambot.pid");
printf FILE "$$\n";
close(FILE);

undef(@on_join_handler);
undef(@on_part_handler);
undef(@on_quit_handler);
undef(@on_msg_handler);

do "$config";

if (defined($newdatadir)) { $datadir = $newdatadir; }

$datadir =~ s/~/$ENV{HOME}/;
$logdir  =~ s/~/$ENV{HOME}/;

use Socket;

#use Thread;

$help{raw}   = "Syntax: .raw <text>\nSends <text> directly to the server.";
$help{order} = "Syntax: .order <text>\nSends <text> directly to the server.";
$help{quote} = "Syntax: .quote <text>\nSends <text> directly to the server.";
$help{ctcp} = "Syntax: .ctcp <user> <text>\nJust like doing /ctcp <user> <text>\nYou can make the bot ctcp version someone by doing .ctcp <nick> VERSION";
$help{cycle} = "Syntax: .cycle <channel>\nRejoins the <channel>.";
$help{addchan} = "Syntax: .addchan <channel> <flags>\nAdds/updates a channel with <flags>. Availabled flags are: modes, log, modelock, topiclock, bitch, opprot, needinvite, freshmeat, slashdot";
$help{setchan} = "Syntax: .setchan <channel> <flags>\nAdds/updates a channel with <flags>. Availabled flags are: modes, log, modelock, topiclock, bitch, opprot, needinvite, freshmeat, slashdot";
$help{remchan} = "Syntax: .remchan <channel>\nRemoves <channel> from channel list.";
$help{chaninfo} = "Syntax: .chaninfo [<channel>]\nDisplays channel settings";
$help{adduser} = "Syntax: .adduser <user> <hostmasks> <flags> <channels>\nAdds/updates an user record.\nHostmasks and channels are separated by commas. Flags aren't seperated.\nPut '*' to channels to give access on every channel\nExample: .adduser spectre ?spectre@*.mylovelyisp.com mo *";
$help{setuser} = "Syntax: .setuser <user> <hostmasks> <flags> <channels>\nAdds/updates an user record.\nHostmasks and channels are separated by commas. Flags aren't seperated.\nPut '*' to channels to give access on every channel\nExample: .setuser spectre ?spectre@*.mylovelyisp.com mo *";
$help{remuser}    = "Syntax: .remuser <user>\nRemoves an user record";
$help{showuser}   = "Syntax: .showuser <user>\nShows the user record";
$help{serverlist} = "Syntax: .serverlist\nPrints server list";
$help{userlist}   = "Syntax: .userlist\nPrints user list";
$help{chanlist}   = "Syntax: .chanlist\nPrints chan list";
$help{save} = "Syntax: .save\nSaves everything (userbase, channels, facts, notes, seen db, top talkers etc)";
$help{topiclock} = "Syntax: .topiclock <on/off> [<channel>]\nEnables/disables topiclock. Specifiy <channel> if you /msg the bot";
$help{modelock} = "Syntax: .modelock <on/off> [<channel>]\nEnables/disables modelock. Specifiy <channel> if you /msg the bot";
$help{bitchmode} = "Syntax: .bitchmode <on/off> [<channel>]\nEnables/disables bitch mode. Specifiy <channel> if you /msg the bot";
$help{opprot} = "Syntax: .opprot <on/off> [<channel>]\nEnables/disables op protection. Specifiy <channel> if you /msg the bot";
$help{log} = "Syntax: .log <on/off> [<channel>]\nEnables/disables channel log. Specifiy <channel> if you /msg the bot";
$help{nick} = "Syntax: .nick <nick>\nChanges bot's nick to <nick>";
$help{join} = "Syntax: .join <channel>\nBot simply joins <channel>. It doesn't add <channel> to the channel list.";
$help{part} = "Syntax: .part <channel>\nBot simply leaves <channel>. It doesn't remove <channel> from the channel list.";
$help{say} = "Syntax: .say <channel> <text>\nMakes bot say <text> on <channel>.";
$help{topic} = "Syntax: .topic <channel> <topic>\nMakes bot set <topic> on <channel>.";
$help{mode} = "Syntax: .mode <channel> <modes>\nMakes bot set <modes> on <channel>.";
$help{op}   = "Syntax: .op <nick>\nBot ops <nick>";
$help{dop}  = "Syntax: .dop <nick>\nBot deops <nick>";
$help{deop} = "Syntax: .deop <nick>\nBot deops <nick>";
$help{kick} = "Syntax: .kick <channel> <nick> <reason>\nMakes bot kick <nick> outta <channel> with <reason>.";
$help{ban} = "Syntax: .ban <channel> <hostmask>\nMakes bot ban <hostmask> on <channel>";
$help{unban} = "Syntax: .unban <channel> <hostmask>\nMakes bot unban <hostmask> on <channel>";
$help{flag} = "Syntax: .flag <user> [+/-]<flags>\nSets, adds, removes user flags";
$help{flags} = "Syntax: .flags <user> [+/-]<flags>\nSets, adds, removes user flags";
$help{addhost} = "Syntax: .addhost <user> <hostmask>\nAdds a new <hostmask> to <user>";
$help{remhost} = "Syntax: .remhost <user> <hostmask>\nRemoves the <hostmask> from <user>";
$help{addchanuser} = "Syntax: .addchanuser <user> <channels>\nGives <user> access on <channels>. You can't add '*' with this command.";
$help{die}     = "Syntax: .die [<reason>]\nBot dies painfully";
$help{restart} = "Syntax: .restart [<reason>]\nRestarts the bot";
$help{jump} = "Syntax: .jump <server>[:<port>]\nBot jumps to the <server>. This command doesn't add <server> to the server list.";
$help{help} = "Syntax: .help [<command>]\nGuess what";

@dunno = ('I\'ve no idea',
  'I dunno',
  'never heard about it',
  'no idea',
  'umm.. dunno',
  'lemme think about it');

do 'subs.pl';
do 'parser.pl';

$SIG{KILL} = 'terminate';
$SIG{TERM} = 'terminate';
$SIG{INT}  = 'terminate';
$SIG{ALRM} = 'saveall';
$SIG{CHLD} = sub { wait() };

$| = 1;
if ($log eq true)
{
  open(LOGFILE, ">>$logfile");
  printf LOGFILE "\n[start]\n";
}

loadchannels();
loadusers();
loadnotes();
loadfacts();
loadseen();
loadtopiclocks();
loadtalkers();
loadpasswords();
serverconnect();

alarm 3600;

while (1)
{
  $ln = getline($sock);
  if ($ln ne "") { parser($ln); }
}
